import { Component, OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { Main } from 'src/app/models/main.model';
import { Mainsyntax } from 'src/app/models/main.model';
import { MainService } from 'src/app/services/main.service';
import {FormControl} from '@angular/forms';
import {Observable} from 'rxjs';
import {map, startWith} from 'rxjs/operators';
import { NotifierService } from "angular-notifier";

@Component({
  selector: 'app-main-details',
  templateUrl: './main-details.component.html',
  styleUrls: ['./main-details.component.scss']
})
export class MainDetailsComponent implements OnInit {
  mainsyntax = [
    {Attributes: [], Id: "", Quantifier: false, Related_to_Subject: [], Subject: [], Verbs: []}];
  mainsyntax11?: Mainsyntax ={
    Attributes : [],
    Quantifier : false,
    Related_to_Subject : [],
    Subject : [],
    Verbs : []
  };

  subjectsControl = new FormControl();
  subjects:string[] = [];
  subjectsfilteredOptions: Observable<string[]>;

  stateitemControl = new FormControl();
  stateitem:string[] = [];
  stateitemfilteredOptions: Observable<string[]>;
  stateitemControlisDivVisible = false

  statevalueControl = new FormControl();
  statevalue:string[] = [];
  statevaluefilteredOptions: Observable<string[]>;
  statevalueControlisDivVisible = false


  shallControl = new FormControl();
  shall:string[] = [];
  shallfilteredOptions: Observable<string[]>;

  verbControl = new FormControl();
  verb:string[] = [];
  verbfilteredOptions: Observable<string[]>;

  quantifierControl = new FormControl();
  quantifier:string[] = [];
  quantifierfilteredOptions: Observable<string[]>;
  quantifierControlisDivVisible = false

  numunitControl = new FormControl();
  numunit:string[] = [];
  numunitfilteredOptions: Observable<string[]>;
  numunitControlisDivVisible = false

  fifuintsysstatsetControl = new FormControl();
  fifuintsysstatset:string[] = [];
  fifuintsysstatsetfilteredOptions: Observable<string[]>;

  stsysconsetControl = new FormControl();
  stsysconset:string[] = [];
  stsysconsetfilteredOptions: Observable<string[]>;
  stsysconsetControlisDivVisible = false

  numericalisDivVisible = false


  public static id: any [] = [];
  private readonly notifier: NotifierService;
  mains?: Main[];

  currentmain: Main  = {
    sys_fun_inter: "",
    state_item_before_verb: "",
    statevalue_before_verb: "",
    shall: "",
    verb: "",
    quantifier: "",
    numerical: 0,
    mumerical_units: "",
    flow_function_interface_item_system_state_stateset: "",
    statevalue_system_connection_stateset: "",
  };
  message = '';

  constructor(
    private mainService: MainService,
    private route: ActivatedRoute,
    private router: Router, 
    notifierService: NotifierService) { 
    this.notifier = notifierService;
    this.subjectsfilteredOptions = this.subjectsControl.valueChanges.pipe(
      startWith(""),
      map(value => this._filter(this.subjects, value))
    );
    this.stateitemfilteredOptions = this.stateitemControl.valueChanges.pipe(
      startWith(""),
      map(value => this._filter(this.stateitem, value))
    ); 
    this.statevaluefilteredOptions = this.statevalueControl.valueChanges.pipe(
      startWith(""),
      map(value => this._filter(this.statevalue, value))
    ); 
    this.shallfilteredOptions = this.shallControl.valueChanges.pipe(
      startWith(""),
      map(value => this._filter(this.shall, value))
    );
    this.verbfilteredOptions = this.verbControl.valueChanges.pipe(
      startWith(""),
      map(value => this._filter(this.verb, value))
    );
    this.quantifierfilteredOptions = this.quantifierControl.valueChanges.pipe(
      startWith(""),
      map(value => this._filter(this.quantifier, value))
    );
    this.numunitfilteredOptions = this.numunitControl.valueChanges.pipe(
      startWith(""),
      map(value => this._filter(this.numunit, value))
    ); 
    this.fifuintsysstatsetfilteredOptions = this.fifuintsysstatsetControl.valueChanges.pipe(
      startWith(""),
      map(value => this._filter(this.fifuintsysstatset, value))
    );
    this.stsysconsetfilteredOptions = this.stsysconsetControl.valueChanges.pipe(
      startWith(""),
      map(value => this._filter(this.stsysconset, value))
    );
  }

  ngOnInit(): void {
    this.getchoices(); 
    this.getAllMain(this.route.snapshot.params.id);
  }

  ngDoCheck() {
    this.dis();
  }

  dis(): any{
    //Check for each M1-M16
    for (let x=0; x < this.mainsyntax.length; x++ ){
    //for (let x=0; x < 1; x++ ){
      //console.log(this.mainsyntax[x])
      //console.log(this.mainsyntax[x].Id)
      for (let s=0; s < this.mainsyntax[x].Subject.length; s++ ){
        if (this.mainsyntax[x].Subject[s] == (this.subjectsControl.value.slice(0, this.subjectsControl.value.indexOf(':'))).replace(/\s/g, "")){
            //console.log("okk")
            for (let v=0; v < this.mainsyntax[x].Verbs.length; v++ ){
              if (this.mainsyntax[x].Verbs[v] == ((this.verbControl.value).replace(/\s/g, ""))){
                //console.log("Verb okk")
            for (let a=0; a < this.mainsyntax[x].Attributes.length; a++ ){
              if (this.mainsyntax[x].Attributes[a] == (this.fifuintsysstatsetControl.value.slice(0, this.fifuintsysstatsetControl.value.indexOf(':'))).replace(/\s/g, "")){
                console.log("Attribute okk", this.mainsyntax[x].Id)
                if (this.mainsyntax[x].Related_to_Subject.length > 0 ){
                  this.stateitemControlisDivVisible = true
                  for (let r=0; r < this.mainsyntax[x].Related_to_Subject.length; r++ ){
                    if (this.mainsyntax[x].Related_to_Subject[r] == "StateValue"){this.statevalueControlisDivVisible = true; }
                    }
                }
                console.log(this.mainsyntax[x].Quantifier)
                if (this.mainsyntax[x].Quantifier){
                  //this.quantifierControl.enable();
                  this.quantifierControlisDivVisible = true;
                  this.numericalisDivVisible = true;
                  //numerical value
                  this.numunitControlisDivVisible = true;
                  //add the numunit data
                }
                if (this.mainsyntax[x].Attributes.length > 1){
                  this.stsysconsetControlisDivVisible = true;
                  //add the connection data
                  return 1;
                }
              }
            }
            }
          }
        }
    }
    //Related to System
    this.stateitemControlisDivVisible = false;
    this.statevalueControlisDivVisible = false;
    //Quantifier
    //this.quantifierControl.markAsUntouched();
    this.quantifierControlisDivVisible = false;
    //numerical value
    this.numunitControlisDivVisible = false;
    this.numericalisDivVisible = false;
    // Extra Attribute
    this.stsysconsetControlisDivVisible = false;
  }
}

  displayFn(option:string): string {
    if (option != null) {
      let x = option.split(" : ");
      if ( (x[x.length -2] == "") || (x[x.length -1]=="")) { return "";}
      return (x[x.length -2]+" : "+x[x.length -1]);
    }
    return "";
  }

  private _filter(data:string[], value: string): string[] {
    const filterValue = value.toLowerCase();
    return data.filter(option => option.toLowerCase().includes(filterValue));
  }

  getAllMain(id: string): void {
    this.mainService.getAll(id)
      .subscribe(
        data => {
          MainDetailsComponent.id.length =0;
          this.mains = data;
          for (var val of data) {
            MainDetailsComponent.id.push(val.id);
            this.getMain(id, val.id);
          }
        },
        error => {
          console.log(error);
        });
  }
  getMain(main: any, id: string): void {
    //PrefixDetailsComponent.id = id;
    this.mainService.get(main, id)
      .subscribe(
        data => {
          this.currentmain = data;
          //console.log(data)
          this.subjectsControl.setValue(this.currentmain.sys_fun_inter);
          this.stateitemControl.setValue(this.currentmain.state_item_before_verb);
          this.statevalueControl.setValue(this.currentmain.statevalue_before_verb);
          this.shallControl.setValue(this.currentmain.shall);
          this.verbControl.setValue(this.currentmain.verb);
          this.quantifierControl.setValue(this.currentmain.quantifier);
          // num
          this.numunitControl.setValue(this.currentmain.mumerical_units);
          this.fifuintsysstatsetControl.setValue(this.currentmain.flow_function_interface_item_system_state_stateset);
          this.stsysconsetControl.setValue(this.currentmain.statevalue_system_connection_stateset);
        },
        error => {
          console.log(error);
        });
  }


  updateMain(): void {
    this.currentmain.sys_fun_inter = this.subjectsControl.value;
    if( this.stateitemControlisDivVisible){this.currentmain.state_item_before_verb = this.stateitemControl.value;}
    if (this.statevalueControlisDivVisible){this.currentmain.statevalue_before_verb = this.statevalueControl.value;}
    this.currentmain.shall = this.shallControl.value;
    this.currentmain.verb = this.verbControl.value;
    if (this.quantifierControlisDivVisible){this.currentmain.quantifier = this.quantifierControl.value;}
    //num
    if (this.numericalisDivVisible){this.currentmain.mumerical_units = this.numunitControl.value;}
    this.currentmain.flow_function_interface_item_system_state_stateset = this.fifuintsysstatsetControl.value;
    if (this.stsysconsetControlisDivVisible){this.currentmain.statevalue_system_connection_stateset = this.stsysconsetControl.value;}
    for (let i=0; i<MainDetailsComponent.id.length; i++){
    this.mainService.update(this.route.snapshot.params.id, MainDetailsComponent.id[i], this.currentmain)
      .subscribe(
        response => {
          this.notifier.notify("success",JSON.stringify("Prefix updated"));
          this.message = response.message;
        },
        error => {
          console.log(error);
          this.notifier.notify("warning",(JSON.stringify(error["error"])));
        });}
  }


  getchoices(): void{
    this.mainService.getsubject()
      .subscribe(
        data => {
          for (let x=0; x < data.length; x++ ){
          this.subjects.push((data[x][1]));}
        },
        error => {
          console.log(error);
        });
    
    this.mainService.getstateitem()
    .subscribe(
      data => {
        //no data from State and Item
        for (let x=0; x < data.length; x++ ){
        this.stateitem.push(data[x][1]);}
      },
      error => {
        console.log(error);
      });
    this.mainService.getstatevalue()
    .subscribe(
      data => {
        for (let x=0; x < data.length; x++ ){
        this.statevalue.push(data[x][1]);}
      },
      error => {
        console.log(error);
      });
    this.mainService.getshall()
    .subscribe(
      data => {
        for (let x=0; x < data.length; x++ ){
        this.shall.push(data[x][1]);}
      },
      error => {
        console.log(error);
      });
    this.mainService.getverb()
    .subscribe(
      data => {
        for (let x=0; x < data.length; x++ ){
        this.verb.push(data[x][1]);}
      },
      error => {
        console.log(error);
      });
    this.mainService.getquantifier()
    .subscribe(
      data => {
        for (let x=0; x < data.length; x++ ){
          this.quantifier.push(data[x][1]);}
      },
      error => {
        console.log(error);
      });
      //num
    this.mainService.getnumunit()
    .subscribe(
      data => {
        for (let x=0; x < data.length; x++ ){
        this.numunit.push(data[x][1]);}
      },
      error => {
        console.log(error);
      });
    this.mainService.getfifuintsysstatset()
    .subscribe(
      data => {
        for (let x=0; x < data.length; x++ ){
        this.fifuintsysstatset.push(data[x][1]);}
      },
      error => {
        console.log(error);
      });
    this.mainService.getstsysconset()
    .subscribe(
      data => {
        for (let x=0; x < data.length; x++ ){
        this.stsysconset.push(data[x][1]);}
      },
      error => {
        console.log(error);
      });

    this.mainService.getmainsyntax()
    .subscribe(
      data => {
        this.mainsyntax = data
      },
      error => {
        console.log(error);
      });
    }
  }


