import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { Prefix } from '../models/prefix.model';

const baseUrl = 'http://155.207.131.19:8000/api-auth/groupboilerplates/0/boilerplates/';
const Url = '/prefix/';

@Injectable({
  providedIn: 'root'
})
export class PrefixService {

  constructor(private http: HttpClient) { }

  getAll(boilerplate: any): Observable<Prefix[]> {
    return this.http.get<Prefix[]>(`${baseUrl}${boilerplate}${Url}`);
  }

  get(boilerplate: any, id: any): Observable<Prefix> {
    return this.http.get(`${baseUrl}${boilerplate}${Url}${id}`);
  }

  create(boilerplate: any, data: any): Observable<any> {
    return this.http.post(`${baseUrl}${boilerplate}${Url}`, data);
  }

  update(boilerplate: any, id: any, data: any): Observable<any> {
    return this.http.put(`${baseUrl}${boilerplate}${Url}${id}/`, data);
  }

  delete(boilerplate: any, id: any): Observable<any> {
    return this.http.delete(`${baseUrl}${boilerplate}${Url}${baseUrl}${id}`);
  }

  getsimpleprefix(): Observable<any> {
    return this.http.get(`http://155.207.131.19:8000/api-auth/prefix/choices/simpleprefix/`);
  }

  getlogcon(): Observable<any> {
    return this.http.get(`http://155.207.131.19:8000/api-auth/prefix/choices/logicalconnectivity/`);
  }

  getverb(): Observable<any> {
    return this.http.get(`http://155.207.131.19:8000/api-auth/prefix/choices/verbprefix/`);
  }

  getsubject(): Observable<any> {
    return this.http.get(`http://155.207.131.19:8000/api-auth/prefix/choices/sysfunitem/`);
  }
  
  getoobject(): Observable<any> {
    return this.http.get(`http://155.207.131.19:8000/api-auth/prefix/choices/staflowfunitem/`);
  }
  //findByTitle(title: any): Observable<Prefix[]> {
  //  return this.http.get<Prefix[]>(`${baseUrl}title=${title}`);
  //}
}
